/* Created by Nelloy (original DooToJass by Raichu)*/

#include <Windows.h>
#include <string>
#include <stdio.h>
#include <tchar.h>
#include <fstream>
#include <iostream>
#include <String>
#include <vector>


using namespace std;

#pragma pack(push,1)
struct w3eheader1
{
	char head[4];
	long version;
	char maintile;
	long iscustomtiles;
	long tilesets;
};

struct w3eheader3
{
	long  Mx;
	long  My;
	float CX;
	float CY;
};

struct w3eData
{
	short grheight; 
	short waterheight; 
	/*int flags:4;
	int groundtt:4;*/
	BYTE flagground;
	BYTE texturedet;
	/*int cliffttype:4;
	int layer:4;*/
	BYTE clifflay;
};

struct doodheader
{
	char head[4];
	long version;
	long subversion;
	long numbertrees;
};

struct dood
{
	char type[4];
	long variation;
	float x;
	float y;
	float z;
	float a;
	float xscale;
	float yscale;
	float zscale;
	BYTE flags;
	BYTE life;
	BYTE randtable[4];
	long dropc;
	long number;
};

struct dood7
{
	char type[4];
	long variation;
	float x;
	float y;
	float z;
	float a;
	float xscale;
	float yscale;
	float zscale;
	BYTE flags;
	BYTE life;
	long number;
};

struct terr_point
{
  string id;
  float x;
  float y;
  int z;
};

struct dood_type
{
  string id;
  string model;
  int red;
  int green;
  int blue;
};

struct w3dheader
{
  int version;
  int changed_doodads;
  int added_doodads;
};

struct w3ddoodad
{
  char base_id[4];
  char new_id[4];
  int modifications;
};

struct w3dmodification
{
  char field_id[4];
  int field_type;
  int variation;
  int data_pointer;
};

struct charr
{
	char bf[4];
};
#pragma pack(pop)



int _tmain(int argc, _TCHAR* argv[])
{
  char answer;
  string name;
  int min_x;
  int min_y;
  int max_x;
  int max_y;
  float CX;
  float CY;
  int size_x;
  int size_y;

  cout << "Convert to Wurst? (y/n)\n";
  std::cin >> answer;
  if (answer != 'y')
    return 0;

  cout << "Enter output package name.\n";
  std::cin >> name;

  cout << "Enter min x\n";
  std::cin >> min_x;
  cout << "Enter max x\n";
  std::cin >> max_x;
  cout << "Enter min y\n";
  std::cin >> min_y;
  cout << "Enter max y\n";
  std::cin >> max_y;

  CX = float(max_x + min_x) / 2;
  CY = float(max_y + min_y) / 2;
  size_x = max_x - min_x;
  size_y = max_y - min_y;

  FILE *f_doo, *f_w3e, *f_w3d, *f_out;
  /* Open files. */
  string file_name = name.c_str();
  file_name += ".wurst";
  fopen_s(&f_doo, "war3map.doo", "rb");
  fopen_s(&f_w3e, "war3map.w3e", "rb");
  fopen_s(&f_w3d, "war3map.w3d", "rb");
  fopen_s(&f_out, file_name.c_str(), "w+");

  /* Start functions. */
  fprintf(f_out, 
    "package %s\n"
    "\n"
    "import public ClassDecorationPreset\n"
    "\n"
    "/* Don't change constants manually. */\n"
    "constant string name = \"%s\"\n",
    name.c_str(), name.c_str());

  /* Read headers. */
  doodheader doohead;
  vector<dood> dood_list;
  std::fread(&doohead, sizeof(doodheader), 1, f_doo);
  /* Some info. */
  printf("\nFILE: %so\nVersion: %d.%d\nnumber:%d\n\n\n\n\n", doohead.head, doohead.version, doohead.subversion, doohead.numbertrees);
  /* Form list. */
  dood cur;
  int dood_count = 0;
  for (int i = 0; i < doohead.numbertrees; i++)
  {
    if (doohead.version == 7)
    {
      dood7 w3do;
      std::fread(&w3do, sizeof(dood7), 1, f_doo);
      cur.a = w3do.a;
      cur.dropc = 0;
      cur.flags = w3do.flags;
      cur.life = w3do.life;
      cur.number = w3do.number;
      cur.randtable[0] = 0x00;
      cur.randtable[1] = 0x00;
      cur.randtable[2] = 0x00;
      cur.randtable[3] = 0x00;
      cur.randtable[4] = 0x00;
      cur.type[0] = w3do.type[0];
      cur.type[1] = w3do.type[1];
      cur.type[2] = w3do.type[2];
      cur.type[3] = w3do.type[3];
      cur.type[4] = w3do.type[4];
      cur.variation = w3do.variation;
      cur.x = w3do.x;
      cur.xscale = w3do.xscale;
      cur.y = w3do.y;
      cur.yscale = w3do.yscale;
      cur.z = w3do.z;
      cur.zscale = w3do.zscale;
    }
    else
    {
      std::fread(&cur, sizeof(dood), 1, f_doo);
    }
    /*  . */
    if (cur.x >= min_x && cur.x <= max_x && cur.y >= min_y && cur.y <= max_y)
    {
      cur.x = cur.x - CX;
      cur.y = cur.y - CY;
      dood_list.push_back (cur);
      dood_count++;
    }
  }
  std::fclose(f_doo);

  /* ------------------------------------------CONVERT .w3e to Wurst by Raichu (fixed by Nelloy)--------------------------------------------------- */
  w3eheader1 w3e_head1;
  std::fread(&w3e_head1, sizeof(w3eheader1), 1, f_w3e);
  printf_s("\nFILE: %.4s\n Version: %d\n Type:%c\n%d\n Tilesets(ground) %d\n", w3e_head1.head, w3e_head1.version, w3e_head1.maintile, w3e_head1.iscustomtiles, w3e_head1.tilesets);
  string *str = new string[w3e_head1.tilesets];
  char tilesets_l[1024];
  std::fread(str, 4, w3e_head1.tilesets, f_w3e);
  printf_s("List: %s\n", &str[0]);
  sprintf_s(tilesets_l, "%s", &str[0]);

  int cliffs;
  char cliffs_l[1024];
  std::fread(&cliffs, 4, 1, f_w3e);
  printf_s("Tilesets(cliffs): %d\n", cliffs);
  str = new string[cliffs];
  std::fread(str, 4, cliffs, f_w3e);
  printf_s("List: %s\n", &str[0]);
  sprintf_s(cliffs_l, "%s", &str[0]);

  w3eheader3 w3e_head2;
  std::fread(&w3e_head2, sizeof(w3eheader3), 1, f_w3e);
  printf_s("\nCX: %f, CY: %f \n MX: %d, MY: %d \n \n \n %d", w3e_head2.CX, w3e_head2.CY, w3e_head2.Mx, w3e_head2.My, sizeof(w3eData));

  vector<terr_point> terr_list;
  w3eData data;
  int groundtt;
  int layer;
  float x;
  float y;
  int height;
  int points_count = 0;

  for (y = w3e_head2.CY; y < w3e_head2.CY + 128 * w3e_head2.My; y += 128)
    for (x = w3e_head2.CX; x < w3e_head2.CX + 128 * w3e_head2.Mx; x += 128)
    {
      std::fread(&data, sizeof(w3eData), 1, f_w3e);
      groundtt = (data.flagground & 15) + 1;
      layer = data.clifflay & 15;
      height = (8192 - data.grheight) / 4 - layer * 128 + 256;
      if (x >= min_x && x <= max_x && y >= min_y && y <= max_y)
      {
        terr_point *tmp = new terr_point;
        tmp->id += tilesets_l[groundtt * 4 - 4];
        tmp-> id += tilesets_l[groundtt * 4 - 3];
        tmp->id += tilesets_l[groundtt * 4 - 2];
        tmp->id += tilesets_l[groundtt * 4 - 1];
        tmp->x = x;
        tmp->y = y;
        tmp->z = height;
        terr_list.push_back(*tmp);

        points_count++;
      }
    } 
  std::fclose(f_w3e);

  /* Convert war3map.w3d to doodad types. */
  w3dheader w3d_head;
  vector<dood_type> type_list;
  std::fread(&w3d_head, sizeof(w3dheader), 1, f_w3d);
  for (int i = 0; i < w3d_head.added_doodads; i++)
  {
    w3ddoodad dood;
    std::fread(&dood, sizeof(w3ddoodad), 1, f_w3d);

    dood_type *_type = new dood_type;
    _type->id = dood.new_id;
    _type->model = "";
    _type->red = 255;
    _type->green = 255;
    _type->blue = 255;

    for (int j = 0; j < dood.modifications; j++)
    {
      w3dmodification change;
      std::fread(&change, sizeof(w3dmodification), 1, f_w3d);
      if (change.field_type == 0)
      {
        int data_int;
        std::fread(&data_int, sizeof(int), 1, f_w3d);
        if (strncmp(&change.field_id[0], "dvr1", 4) == 0)
          _type->red = data_int;
        if (strncmp(&change.field_id[0], "dvg1", 4) == 0)
          _type->green = data_int;
        if (strncmp(&change.field_id[0], "dvb1", 4) == 0)
          _type->blue = data_int;
      }
      else if (change.field_type == 1 || change.field_type == 2)
      {
        /* float  . */
        float data_float;
        std::fread(&data_float, sizeof(float), 1, f_w3d);
      }
      else if (change.field_type == 3)
      {
        string data_string;
        char ch;
        std::fread(&ch, sizeof(char), 1, f_w3d);
        while (ch != '\0')
        {
          if (ch == '\\')
            data_string += '\\';
          data_string += ch;
          std::fread(&ch, sizeof(char), 1, f_w3d);
        }
        data_string += ch;
        if (strncmp(&change.field_id[0], "dfil", 4) == 0)
          _type->model = data_string;
      }
      int tmp;
      std::fread(&tmp, sizeof(int), 1, f_w3d);
    }
    type_list.push_back(*_type);
  }

  /*    .*/
  for (int i = 0; i < type_list.size(); i++)
  {
    bool found = false;
    for (int j = 0; j < dood_list.size(); j++)
      if (strncmp(&type_list[i].id[0], &dood_list[j].type[0], 4) == 0)
      {
        found = true;
        break;
      }
    if (!found)
    {
      type_list.erase(type_list.begin() + i);
      i--;
    }
  }
  
  fprintf(f_out,
    "constant real size_x = %.2f\n"
    "constant real size_y = %.2f\n"
    "constant int destr_count = %d\n"
    "constant int points_count = %d\n"
    "constant int types_count = %d\n"
    "\n"
    "decorationTuple array used_types\n"
    "LinkedList<DecorationData> decorations\n"
    "LinkedList<TerrainData> terrain\n"
    "public DecorationPreset dp_%s\n"
    "\n"
    "\n",
    name, float(size_x), float(size_y), dood_count, points_count, type_list.size());
  /* . */
  fprintf(f_out,
    "init\n"
    "    addTypesData()\n"
    "    for i = 0 to types_count\n"
    "        addDecorationType(used_types[i])\n"
    "    addDecorationData()\n"
    "    addTerrainData()\n"
    "    dp_%s = new DecorationPreset(name, decorations, terrain)\n"
    "\n"
    "\n"
    "function getNewId(int old_id) returns int\n"
    "    for i = 0 to types_count\n"
    "        if used_types[i].old_id == old_id\n"
    "            return used_types[i].new_id\n"
    "    return -1\n",
    name.c_str());
  /*    . */
  fprintf(f_out, 
    "\n"
    "\n"
    "function addTypesData ()\n");
  for (int i = 0; i < type_list.size(); i++)
    fprintf_s(f_out,
      "    used_types[%d] = compiletime(registerDecorationType('%.4s', \"%s\", %d, %d, %d))\n",
      i, &type_list[i].id[0], &type_list[i].model[0], type_list[i].red, type_list[i].green, type_list[i].blue);
  /*   . */
  fprintf(f_out,
    "\n"
    "\n"
    "function addDecorationData ()\n");
  for (int i = 0; i < dood_list.size(); i++)
    fprintf(f_out,
      "    decorations.add (new DecorationData ('%.4s', getNewId('%.4s'), %.2f, %.2f, %.2f, %.6f, %.2f, 1))\n",
      &dood_list[i].type[0], &dood_list[i].type[0], dood_list[i].x, dood_list[i].y, dood_list[i].z, dood_list[i].a, dood_list[i].zscale);
  /*   . */
  fprintf(f_out,
    "\n"
    "\n"
    "function addTerrainData ()\n");
  for (int i = 0; i < terr_list.size(); i++)
    fprintf(f_out,
      "    terrain.add (new TerrainData ('%.4s', %.2f, %.2f, %d))\n", &terr_list[i].id[0], terr_list[i].x, terr_list[i].y, terr_list[i].z);


  std::cin >> answer;
  std::fclose(f_out);
  return 0;
}